forked from fishercoder1534/Leetcode
-
Notifications
You must be signed in to change notification settings - Fork 0
/
Copy path_970.java
52 lines (49 loc) · 1.66 KB
/
_970.java
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
package com.fishercoder.solutions;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
public class _970 {
public static class Solution1 {
/**
* This approach results in Time Limit Exceeded since it's apparently doing
* redundant checks.
*/
public List<Integer> powerfulIntegers(int x, int y, int bound) {
Set<Integer> result = new HashSet<>();
int small = x;
int big = y;
if (x > y) {
small = y;
big = x;
}
int maxPower = bound / small;
for (int i = 0; i <= maxPower + 1; i++) {
for (int j = 0; j <= maxPower + 1; j++) {
int sum = (int) (Math.pow(small, i) + Math.pow(big, j));
if (sum <= bound) {
result.add(sum);
}
}
}
List<Integer> list = new ArrayList<>(result);
Collections.sort(list);
return list;
}
}
public static class Solution2 {
/**
* credit: https://leetcode.com/problems/powerful-integers/discuss/214212/JavaC%2B%2BPython-Brute-Force
*/
public List<Integer> powerfulIntegers(int x, int y, int bound) {
Set<Integer> result = new HashSet<>();
for (int i = 1; i < bound; i *= x > 1 ? x : bound + 1) {
for (int j = 1; i + j <= bound; j *= y > 1 ? y : bound + 1) {
result.add(i + j);
}
}
return new ArrayList<>(result);
}
}
}